//+------------------------------------------------------------------+
//|                                            Check2MAsCrossing.mq4 |
//|                        Copyright  2011, VladislavVG (VG,VladVG) |
//|                                                   4vg AT mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, VladislavVG (VG,VladVG)"
#property link      "4vg AT mail.ru"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Aqua
#property indicator_width1 3
#property indicator_color2 Yellow
#property indicator_width2 3
#property indicator_color3 Red
#property indicator_color4 Blue
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
extern int FastP = 10;
extern int FastMAMode  = MODE_EMA;
extern int FastPrcType = PRICE_CLOSE;
extern int SlowP = 50;
extern int SlowMAMode  = MODE_EMA;
extern int SlowPrcType = PRICE_CLOSE;

string SYMBOL="";
int    IndTF = 0;
double fastMA[];
double slowMA[];
double UpCrossing[];
double DnCrossing[];

int init()
{
//---- indicators
    SYMBOL= Symbol();
    IndTF = Period();
    SetIndexBuffer(0,UpCrossing);SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,SYMBOL_ARROWUP);
    SetIndexBuffer(1,DnCrossing);SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,SYMBOL_ARROWDOWN);
    SetIndexBuffer(2,fastMA);    SetIndexStyle(2, DRAW_LINE);
    SetIndexBuffer(3,slowMA);    SetIndexStyle(3, DRAW_LINE);
    IndicatorShortName("Check2MAsCrossing(" + FastP + "," + SlowP + ")");
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
//----
int i=Bars-IndicatorCounted();
    for(;i>=0;i-- )
    {
        fastMA[i] = iMA(SYMBOL, IndTF, FastP, 0, FastMAMode, FastPrcType, i);
        slowMA[i] = iMA(SYMBOL, IndTF, SlowP, 0, SlowMAMode, SlowPrcType, i);
        double dMA = Check2MAsCrossingDirection(SYMBOL, IndTF, FastP, SlowP, 
                                                               FastMAMode, FastPrcType, 
                                                               SlowMAMode, SlowPrcType,
                                                               i,0.5);
        if(dMA > 0 )
            UpCrossing[i] = Low[i] - 25*Point;
        else  
            if(dMA < 0 )
                DnCrossing[i] = High[i] + 25*Point;

    }
//----
    return(0);
}
//+------------------------------------------------------------------+

double Check2MAsCrossingDirection(
                    string SYMBL, int TF, 
                    int maFastPeriod, int maSlowPeriod, 
                    int maFastMode=MODE_EMA, int maFast_PriceType = PRICE_CLOSE,
                    int maSlowMode=MODE_EMA, int maSlow_PriceType = PRICE_CLOSE,
                    int bn = 1,
                    double porogInPoints = 0.5)
{
double dMA[] = {0,0};
    dMA[0] = iMA(SYMBL, TF, maFastPeriod, 0, maFastMode, maFast_PriceType, bn) - 
             iMA(SYMBL, TF, maSlowPeriod, 0, maSlowMode, maSlow_PriceType, bn);
    if( MathAbs(dMA[0])<(porogInPoints*Point) )
        return(0);// 
int  k = bn+1;
    while(k<Bars)
    {
        dMA[1] = iMA(SYMBL, TF, maFastPeriod, 0, maFastMode, maFast_PriceType,  k) - 
                 iMA(SYMBL, TF, maSlowPeriod, 0, maSlowMode, maSlow_PriceType,  k);
        if(MathAbs(dMA[1])>=(porogInPoints*Point)) break;
        k++;
    }
    if(dMA[0]*dMA[1]<0)
        return(dMA[0]);
    return(0);
}

